/**
 * 
 */
package proglang.j2ee.ejbs;

import java.util.Collection;

import javax.jms.Message;
import javax.jms.ObjectMessage;

import proglang.j2ee.helpers.PlacedOrder;

/**
 * <!-- begin-xdoclet-definition -->
 * ejb.bean name="ProcessOrder" 
 *     acknowledge-mode="Auto-acknowledge"
 *     destination-type="javax.jms.Queue" *     
 *     transaction-type="Container"
 *     destination-jndi-name="OrderQueue"
 *     
 * ejb.transaction="Supports"
 *
 * <!-- end-xdoclet-definition -->
 * @generated
 **/

public class ProcessOrderBean implements javax.ejb.MessageDrivenBean, javax.jms.MessageListener
{

	/** 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * The context for the message-driven bean, set by the EJB container. 
	 * @generated
	 */
	private javax.ejb.MessageDrivenContext messageContext = null;

	/** 
	 * Required method for container to set context.
	 * @generated 
	 */
	public void setMessageDrivenContext(javax.ejb.MessageDrivenContext messageContext) throws javax.ejb.EJBException
	{
		this.messageContext = messageContext;
	}

	/** 
	 * Required creation method for message-driven beans. 
	 *
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * <!-- begin-xdoclet-definition -->
	 * @ejb.create-method 
	 * <!-- end-xdoclet-definition -->
	 * @generated
	 */
	public void ejbCreate()
	{
		//no specific action required for message-driven beans 
	}

	/** 
	 * Required removal method for message-driven beans. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void ejbRemove()
	{
		messageContext = null;
	}

	/** 
	 * This method implements the business logic for the EJB. 
	 * 
	 * <p>Make sure that the business logic accounts for asynchronous message processing. 
	 * For example, it cannot be assumed that the EJB receives messages in the order they were 
	 * sent by the client. Instance pooling within the container means that messages are not 
	 * received or processed in a sequential order, although individual onMessage() calls to 
	 * a given message-driven bean instance are serialized. 
	 * 
	 * <p>The <code>onMessage()</code> method is required, and must take a single parameter 
	 * of type javax.jms.Message. The throws clause (if used) must not include an application 
	 * exception. Must not be declared as final or static. 
	 *
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void onMessage(Message message)
	{		
		System.out.println(" ** Message Driven Bean ProcessOrder got message " + message + " **");
		if (message instanceof ObjectMessage)
		{
			try
			{
				// unpack message
				ObjectMessage objMsg = (ObjectMessage) message;
				PlacedOrder order = (PlacedOrder) objMsg.getObject();
				bookOrder(order);
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
				return;
			}
		}
		else
		{
			System.out.println(" ** Message Driven Bean ProcessOrder got message " + message + " **");
		}
	}
	
	public void bookOrder(PlacedOrder order)
	{
		CustomerValue customer;
		Collection<OrderItemValue> shoppingCart;		
		customer = order.getCustomer();
		shoppingCart = order.getShoppingCart();
		
		try
		{
			CustomerLocal cust = CustomerUtil.getLocalHome().findByPrimaryKey(customer.getPrimaryKey());
			//		Neuer Eintrag in der orders Tabelle mit einem Verweis auf unseren Customer
			OrdersLocal ordersLocal = OrdersUtil.getLocalHome().create(cust);

			//		Erstelle für alle Teilbestellungen neue OrderItems und linke sie 	zu der Bestellung.
			for (OrderItemValue item : shoppingCart)
			{
				BookLocal bookLocal = BookUtil.getLocalHome().findByPrimaryKey(item.getBook().getId());
				OrderItemUtil.getLocalHome().create(bookLocal, item.getQuantity(), ordersLocal);
			}
		}
		catch (Exception e)
		{
			this.messageContext.setRollbackOnly();
			e.printStackTrace();
			return;
		}
		System.out.println(" ** ProcessOrderBean: " + order + " was booked succesfully.");
	}
}
